
import CompuCellSetup

from PySteppables import *
import CompuCell
import sys

from random import random

class CellsortPythonSteppable(SteppableBasePy):    

    def __init__(self,_simulator,_frequency=10):
        SteppableBasePy.__init__(self,_simulator,_frequency)
        
    def start(self):
        
        for cell in self.cellList:
            cell.targetVolume=25
            cell.lambdaVolume=2.2
        
    def step(self,mcs):        
        
        for cell in self.cellList:
            cell.targetVolume+=0.5
                        
        
from PySteppables import *
from PySteppablesExamples import MitosisSteppableBase
import CompuCell
import sys

from PlayerPython import *
from math import *


class MitosisSteppable(MitosisSteppableBase):
    def __init__(self,_simulator,_frequency=1):
        MitosisSteppableBase.__init__(self,_simulator, _frequency)
        
        self.mcs=0
        
    def step(self,mcs):
        # print "INSIDE MitosisSteppable"
        self.mcs=mcs
        cells_to_divide=[]
        for cell in self.cellList:
            if cell.volume>50:
                
                cells_to_divide.append(cell)
                
        for cell in cells_to_divide:
            # to change mitosis mode leave one of the below lines uncommented
            self.divideCellRandomOrientation(cell)
            # self.divideCellOrientationVectorBased(cell,1,0,0)                 # this is a valid option
            # self.divideCellAlongMajorAxis(cell)                               # this is a valid option
            # self.divideCellAlongMinorAxis(cell)                               # this is a valid option

    def updateAttributes(self):
        parentCell=self.mitosisSteppable.parentCell
        childCell=self.mitosisSteppable.childCell
        
        parentCell.targetVolume/=2.0
        childCell.targetVolume=parentCell.targetVolume
        childCell.lambdaVolume=parentCell.lambdaVolume
        
        from random import random
        rnd=random()
                
        if self.mcs<600:
            childCell.type=1
        else:
            childCell.type=2
            
        

